import React, { useState } from 'react'
import { Row, Col } from 'antd'
import styles from './index.less'
import classNames from 'classnames';
console.log(styles['My-Menu']);

interface IProps {
  render?: boolean,
  deleteImg: (imgUrl: string) => void
}

const RightClick: React.FC<IProps> = ({
  render = false,
  deleteImg
}) => {

  const [ imgUrl, setImgUrl ] = useState<string>('')

  const closeMyMenu = () => {

    let menu = document.getElementById("My-Menu") as HTMLElement
    
    if (!menu) return
    menu.style.display = 'none';

    window.oncontextmenu = () => true
  }

  if (render) {

    window.oncontextmenu = function (e) {

      console.log('oncontextmenu', e);
      setImgUrl(e?.target?.src)
      e.preventDefault();

      let menu = document.getElementById("My-Menu") as HTMLElement;

      console.log(e.clientX, e.clientY);
      
      menu.style.position = 'fixed'

      menu.style.left = e.clientX + 'px';

      menu.style.top = e.clientY + 'px';

      menu.style.display = 'block'

      menu.style.zIndex = `1000`

    }

    window.onclick = function (e) {

      closeMyMenu()

    }

  } else {
    closeMyMenu()
  }


  const MyMenu = classNames( styles['My-Menu'] )

  const RenderMenu = () => {
    return  <Row id='My-Menu' style={{width: '125px', height: '30px', position: 'absolute', left: 0, top: 0}} className={MyMenu} >
              <Col span={24} style={{height: '30px'}} className={styles.col}  onClick={(e) => deleteImg(imgUrl)}>
                <span style={{color: '#000', width: `100%`, cursor: "pointer"}} >删除</span>
              </Col>
            </Row>
  }

  return <>
    {
      render ? <RenderMenu /> : null
    }
  </>
}

export default RightClick


